"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.durationNS = void 0;
const repl_ns_1 = require("repl-ns");
exports.durationNS = (0, repl_ns_1.ns)('duration', {
    calcDuration(state) {
        const startSec = (0, exports.durationNS)().time2Seconds(state.startTime);
        const endSec = (0, exports.durationNS)().time2Seconds(state.endTime);
        const duration = endSec - startSec;
        if (duration <= 0) {
            throw new Error("End time can't be less than start time");
        }
        return duration;
    },
    time2Seconds(time) {
        const [hh = 0, mm = 0, ss = 0] = (time ?? '').split(':').map(Number);
        return ss + mm * 60 + hh * 60 * 60;
    },
});
