"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.formNS = void 0;
const React = __importStar(require("react"));
const ink_form_1 = require("ink-form");
const nanostores_cjs_1 = require("nanostores-cjs");
const repl_ns_1 = require("repl-ns");
const useStore_1 = require("../src/useStore");
const download_1 = require("../src/download");
exports.formNS = (0, repl_ns_1.ns)('form', {
    Form: () => {
        const url = (0, useStore_1.useStore)((0, exports.formNS)().url$);
        const path = (0, useStore_1.useStore)((0, exports.formNS)().path$);
        const startTime = (0, useStore_1.useStore)((0, exports.formNS)().startTime$);
        const endTime = (0, useStore_1.useStore)((0, exports.formNS)().endTime$);
        const resolution = (0, useStore_1.useStore)((0, exports.formNS)().resolution$);
        return (React.createElement(ink_form_1.Form, { ...(0, exports.formNS)().formProps({ url, path, startTime, endTime, resolution }), onSubmit: state => {
                (0, download_1.downloadNS)().onDownload(state);
            } }));
    },
    formProps: ({ url, path, startTime, endTime, resolution }) => ({
        onChange: (state) => {
            (0, exports.formNS)().url$.set(state.url);
            (0, exports.formNS)().path$.set(state.path);
            (0, exports.formNS)().startTime$.set(state.startTime);
            (0, exports.formNS)().endTime$.set(state.endTime);
            (0, exports.formNS)().resolution$.set(state.resolution);
        },
        form: {
            title: 'Please setup form for downloading video from Youtube',
            sections: [
                {
                    title: '',
                    fields: [
                        {
                            type: 'string',
                            name: 'url',
                            label: 'Youtube URL',
                            regex: RegExp('^https://.*$'),
                            initialValue: url,
                        },
                        {
                            type: 'string',
                            name: 'path',
                            label: 'File location',
                            initialValue: path || `${process.cwd()}/video.mp4`,
                        },
                        {
                            type: 'string',
                            name: 'startTime',
                            label: 'Start time (optional)',
                            regex: RegExp('(^\\d\\d:\\d\\d:\\d\\d$|^$)'),
                            initialValue: startTime,
                        },
                        {
                            type: 'string',
                            name: 'endTime',
                            label: 'End time (optional)',
                            regex: RegExp('(^\\d\\d:\\d\\d:\\d\\d$|^$)'),
                            initialValue: endTime,
                        },
                        {
                            type: 'select',
                            name: 'resolution',
                            label: 'Resolution',
                            initialValue: resolution ?? 'highest',
                            options: [
                                { label: 'highest', value: 'highest' },
                                { label: '720p', value: '720' },
                                { label: '360p', value: '360' },
                            ],
                        },
                    ],
                },
            ],
        },
    }),
    url$: (0, nanostores_cjs_1.atom)(''),
    path$: (0, nanostores_cjs_1.atom)(''),
    startTime$: (0, nanostores_cjs_1.atom)(''),
    endTime$: (0, nanostores_cjs_1.atom)(''),
    resolution$: (0, nanostores_cjs_1.atom)('highest'),
});
